#include "Resource.h"
#include "DIALOG.h"

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/
/*********************************************************************
*
*       _cbWin
*/
static void _cbWin(WM_MESSAGE * pMsg) {
  WM_HWIN hItem;
  int     Id;
  int     NCode;
  WM_MESSAGE Message;
  static WM_HWIN hKeypad;

  switch(pMsg->MsgId) {
  case WM_CREATE:
    hItem = EDIT_CreateEx(10, 10, 100, 25, pMsg->hWin, WM_CF_SHOW, 0, GUI_ID_EDIT0, 100);
    //
    // Create keypad with this window as parent.
    //
    hKeypad = GUI_CreateKeyPad(pMsg->hWin);
    break;
  case WM_PAINT:
    GUI_SetBkColor(GUI_BLACK);
    GUI_Clear();
    break;
  case WM_NOTIFY_PARENT:
    Id    = WM_GetId(pMsg->hWinSrc);
    NCode = pMsg->Data.v;
    switch(Id) {
    case GUI_ID_EDIT0:
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        break;
      case WM_NOTIFICATION_RELEASED:
        //
        // When EDIT widget was clicked, send a message to keypad to animate it.
        //
        Message.Data.v  = 1;
        Message.MsgId   = MSG_ANIMATE;
        Message.hWin    = hKeypad;
        Message.hWinSrc = pMsg->hWin;
        WM_SendMessage(hKeypad, &Message);
        break;
      }
      break;
    }
    break;
  default:
    WM_DefaultProc(pMsg);
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       MainTask
*/
void MainTask(void) {
  WM_HWIN hWin;

  //
  // Init GUI
  //
  GUI_Init();
  WM_MULTIBUF_Enable(1);
  WM_SetDesktopColor(GUI_BLACK);
  //
  // Create a parent window
  //
  hWin = WM_CreateWindow(0, 0, LCD_GetXSize(), LCD_GetYSize(), WM_CF_SHOW, _cbWin, 0);

  while (1) {
    GUI_Delay(100);
  }
}

/*************************** End of file ****************************/